/* rygel-cmdline-config.c generated by valac, the Vala compiler
 * generated from rygel-cmdline-config.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Nokia Corporation.
 * Copyright (C) 2008,2009 Zeeshan Ali (Khattak) <zeeshanak@gnome.org>.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gst/gst.h>
#include <stdio.h>


#define RYGEL_TYPE_CONFIGURATION (rygel_configuration_get_type ())
#define RYGEL_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CONFIGURATION, RygelConfiguration))
#define RYGEL_IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CONFIGURATION))
#define RYGEL_CONFIGURATION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), RYGEL_TYPE_CONFIGURATION, RygelConfigurationIface))

typedef struct _RygelConfiguration RygelConfiguration;
typedef struct _RygelConfigurationIface RygelConfigurationIface;

#define RYGEL_TYPE_LOG_LEVEL (rygel_log_level_get_type ())

#define RYGEL_TYPE_CMDLINE_CONFIG (rygel_cmdline_config_get_type ())
#define RYGEL_CMDLINE_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CMDLINE_CONFIG, RygelCmdlineConfig))
#define RYGEL_CMDLINE_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_CMDLINE_CONFIG, RygelCmdlineConfigClass))
#define RYGEL_IS_CMDLINE_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CMDLINE_CONFIG))
#define RYGEL_IS_CMDLINE_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_CMDLINE_CONFIG))
#define RYGEL_CMDLINE_CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_CMDLINE_CONFIG, RygelCmdlineConfigClass))

typedef struct _RygelCmdlineConfig RygelCmdlineConfig;
typedef struct _RygelCmdlineConfigClass RygelCmdlineConfigClass;
typedef struct _RygelCmdlineConfigPrivate RygelCmdlineConfigPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))

typedef enum  {
	RYGEL_CMDLINE_CONFIG_ERROR_VERSION_ONLY
} RygelCmdlineConfigError;
#define RYGEL_CMDLINE_CONFIG_ERROR rygel_cmdline_config_error_quark ()
typedef enum  {
	RYGEL_LOG_LEVEL_INVALID = 0,
	RYGEL_LOG_LEVEL_CRITICAL = 1,
	RYGEL_LOG_LEVEL_ERROR = 2,
	RYGEL_LOG_LEVEL_WARNING = 3,
	RYGEL_LOG_LEVEL_INFO = 4,
	RYGEL_LOG_LEVEL_DEFAULT = 4,
	RYGEL_LOG_LEVEL_DEBUG = 5
} RygelLogLevel;

struct _RygelConfigurationIface {
	GTypeInterface parent_iface;
	gboolean (*get_upnp_enabled) (RygelConfiguration* self, GError** error);
	char* (*get_interface) (RygelConfiguration* self, GError** error);
	gint (*get_port) (RygelConfiguration* self, GError** error);
	gboolean (*get_transcoding) (RygelConfiguration* self, GError** error);
	gboolean (*get_mp3_transcoder) (RygelConfiguration* self, GError** error);
	gboolean (*get_mp2ts_transcoder) (RygelConfiguration* self, GError** error);
	gboolean (*get_lpcm_transcoder) (RygelConfiguration* self, GError** error);
	gboolean (*get_wmv_transcoder) (RygelConfiguration* self, GError** error);
	RygelLogLevel (*get_log_level) (RygelConfiguration* self, GError** error);
	gboolean (*get_enabled) (RygelConfiguration* self, const char* section, GError** error);
	char* (*get_title) (RygelConfiguration* self, const char* section, GError** error);
	char* (*get_string) (RygelConfiguration* self, const char* section, const char* key, GError** error);
	GeeArrayList* (*get_string_list) (RygelConfiguration* self, const char* section, const char* key, GError** error);
	gint (*get_int) (RygelConfiguration* self, const char* section, const char* key, gint min, gint max, GError** error);
	GeeArrayList* (*get_int_list) (RygelConfiguration* self, const char* section, const char* key, GError** error);
	gboolean (*get_bool) (RygelConfiguration* self, const char* section, const char* key, GError** error);
};

struct _RygelCmdlineConfig {
	GObject parent_instance;
	RygelCmdlineConfigPrivate * priv;
};

struct _RygelCmdlineConfigClass {
	GObjectClass parent_class;
};

typedef enum  {
	RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET,
	RYGEL_CONFIGURATION_ERROR_VALUE_OUT_OF_RANGE
} RygelConfigurationError;
#define RYGEL_CONFIGURATION_ERROR rygel_configuration_error_quark ()

static char* rygel_cmdline_config_iface;
static char* rygel_cmdline_config_iface = NULL;
static gint rygel_cmdline_config_port;
static gint rygel_cmdline_config_port = 0;
static gboolean rygel_cmdline_config_no_transcoding;
static gboolean rygel_cmdline_config_no_transcoding = FALSE;
static gboolean rygel_cmdline_config_no_mp3_trans;
static gboolean rygel_cmdline_config_no_mp3_trans = FALSE;
static gboolean rygel_cmdline_config_no_mp2ts_trans;
static gboolean rygel_cmdline_config_no_mp2ts_trans = FALSE;
static gboolean rygel_cmdline_config_no_lpcm_trans;
static gboolean rygel_cmdline_config_no_lpcm_trans = FALSE;
static gboolean rygel_cmdline_config_no_wmv_trans;
static gboolean rygel_cmdline_config_no_wmv_trans = FALSE;
static RygelLogLevel rygel_cmdline_config_log_level;
static RygelLogLevel rygel_cmdline_config_log_level = RYGEL_LOG_LEVEL_INVALID;
static gboolean rygel_cmdline_config_version;
static gboolean rygel_cmdline_config_version = FALSE;
static char** rygel_cmdline_config_disabled_plugins;
static char** rygel_cmdline_config_disabled_plugins = NULL;
static char** rygel_cmdline_config_plugin_titles;
static char** rygel_cmdline_config_plugin_titles = NULL;
static char** rygel_cmdline_config_plugin_options;
static char** rygel_cmdline_config_plugin_options = NULL;
static RygelCmdlineConfig* rygel_cmdline_config_config;
static RygelCmdlineConfig* rygel_cmdline_config_config = NULL;
static gpointer rygel_cmdline_config_parent_class = NULL;
static RygelConfigurationIface* rygel_cmdline_config_rygel_configuration_parent_iface = NULL;

GQuark rygel_cmdline_config_error_quark (void);
GType rygel_log_level_get_type (void);
GType rygel_configuration_get_type (void);
GType rygel_cmdline_config_get_type (void);
enum  {
	RYGEL_CMDLINE_CONFIG_DUMMY_PROPERTY
};
RygelCmdlineConfig* rygel_cmdline_config_new (void);
RygelCmdlineConfig* rygel_cmdline_config_construct (GType object_type);
RygelCmdlineConfig* rygel_cmdline_config_get_default (void);
void rygel_cmdline_config_parse_args (char*** args, int* args_length1, GError** error);
GQuark rygel_configuration_error_quark (void);
static gboolean rygel_cmdline_config_real_get_upnp_enabled (RygelConfiguration* base, GError** error);
static char* rygel_cmdline_config_real_get_interface (RygelConfiguration* base, GError** error);
static gint rygel_cmdline_config_real_get_port (RygelConfiguration* base, GError** error);
static gboolean rygel_cmdline_config_real_get_transcoding (RygelConfiguration* base, GError** error);
static gboolean rygel_cmdline_config_real_get_mp3_transcoder (RygelConfiguration* base, GError** error);
static gboolean rygel_cmdline_config_real_get_mp2ts_transcoder (RygelConfiguration* base, GError** error);
static gboolean rygel_cmdline_config_real_get_lpcm_transcoder (RygelConfiguration* base, GError** error);
static gboolean rygel_cmdline_config_real_get_wmv_transcoder (RygelConfiguration* base, GError** error);
static RygelLogLevel rygel_cmdline_config_real_get_log_level (RygelConfiguration* base, GError** error);
static gboolean rygel_cmdline_config_real_get_enabled (RygelConfiguration* base, const char* section, GError** error);
static char* rygel_cmdline_config_real_get_title (RygelConfiguration* base, const char* section, GError** error);
static char* rygel_cmdline_config_real_get_string (RygelConfiguration* base, const char* section, const char* key, GError** error);
static GeeArrayList* rygel_cmdline_config_real_get_string_list (RygelConfiguration* base, const char* section, const char* key, GError** error);
static gint rygel_cmdline_config_real_get_int (RygelConfiguration* base, const char* section, const char* key, gint min, gint max, GError** error);
static GeeArrayList* rygel_cmdline_config_real_get_int_list (RygelConfiguration* base, const char* section, const char* key, GError** error);
static gboolean rygel_cmdline_config_real_get_bool (RygelConfiguration* base, const char* section, const char* key, GError** error);
static void rygel_cmdline_config_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);

static const GOptionEntry RYGEL_CMDLINE_CONFIG_options[13] = {{"version", (gchar) 0, 0, G_OPTION_ARG_NONE, &rygel_cmdline_config_version, "Display version number", NULL}, {"network-interface", 'n', 0, G_OPTION_ARG_STRING, &rygel_cmdline_config_iface, "Network Interface", "INTERFACE"}, {"port", 'p', 0, G_OPTION_ARG_INT, &rygel_cmdline_config_port, "Port", "PORT"}, {"disable-transcoding", 't', 0, G_OPTION_ARG_NONE, &rygel_cmdline_config_no_transcoding, "Disable transcoding", NULL}, {"disable-mp3-transcoder", 'm', 0, G_OPTION_ARG_NONE, &rygel_cmdline_config_no_mp3_trans, "Disable MP3 transcoder", NULL}, {"disable-mp2ts-transcoder", 's', 0, G_OPTION_ARG_NONE, &rygel_cmdline_config_no_mp2ts_trans, "Disable mpeg2 transport stream transcoder", NULL}, {"disable-lpcm-transcoder", 'l', 0, G_OPTION_ARG_NONE, &rygel_cmdline_config_no_lpcm_trans, "Disable Linear PCM transcoder", NULL}, {"disable-wmv-transcoder", 'l', 0, G_OPTION_ARG_NONE, &rygel_cmdline_config_no_wmv_trans, "Disable WMV transcoder", NULL}, {"log-level", 'g', 0, G_OPTION_ARG_INT, &rygel_cmdline_config_log_level, "Log level. 1=critical,2=error,3=warning,4=message/info,5=debug", "N"}, {"disable-plugin", 'd', 0, G_OPTION_ARG_STRING_ARRAY, &rygel_cmdline_config_disabled_plugins, "Disable plugin", "PluginName"}, {"title", 'i', 0, G_OPTION_ARG_STRING_ARRAY, &rygel_cmdline_config_plugin_titles, "Set plugin titles", "PluginName:TITLE"}, {"plugin-option", 'o', 0, G_OPTION_ARG_STRING_ARRAY, &rygel_cmdline_config_plugin_options, "Set plugin options", "PluginName:OPTION:VALUE1[,VALUE2,..]"}, {NULL}};


GQuark rygel_cmdline_config_error_quark (void) {
	return g_quark_from_static_string ("rygel_cmdline_config_error-quark");
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 94 "rygel-cmdline-config.vala"
RygelCmdlineConfig* rygel_cmdline_config_get_default (void) {
#line 189 "rygel-cmdline-config.c"
	RygelCmdlineConfig* result = NULL;
#line 95 "rygel-cmdline-config.vala"
	if (rygel_cmdline_config_config == NULL) {
#line 193 "rygel-cmdline-config.c"
		RygelCmdlineConfig* _tmp0_;
#line 96 "rygel-cmdline-config.vala"
		rygel_cmdline_config_config = (_tmp0_ = rygel_cmdline_config_new (), _g_object_unref0 (rygel_cmdline_config_config), _tmp0_);
#line 197 "rygel-cmdline-config.c"
	}
	result = _g_object_ref0 (rygel_cmdline_config_config);
#line 99 "rygel-cmdline-config.vala"
	return result;
#line 202 "rygel-cmdline-config.c"
}


#line 102 "rygel-cmdline-config.vala"
void rygel_cmdline_config_parse_args (char*** args, int* args_length1, GError** error) {
#line 208 "rygel-cmdline-config.c"
	GError * _inner_error_;
	char* parameter_string;
	GOptionContext* opt_context;
	_inner_error_ = NULL;
#line 105 "rygel-cmdline-config.vala"
	parameter_string = g_strdup ("- " PACKAGE_NAME);
#line 106 "rygel-cmdline-config.vala"
	opt_context = g_option_context_new (parameter_string);
#line 107 "rygel-cmdline-config.vala"
	g_option_context_set_help_enabled (opt_context, TRUE);
#line 108 "rygel-cmdline-config.vala"
	g_option_context_add_main_entries (opt_context, RYGEL_CMDLINE_CONFIG_options, NULL);
#line 109 "rygel-cmdline-config.vala"
	g_option_context_add_group (opt_context, gst_init_get_option_group ());
#line 110 "rygel-cmdline-config.vala"
	g_option_context_parse (opt_context, args_length1, args, &_inner_error_);
#line 225 "rygel-cmdline-config.c"
	if (_inner_error_ != NULL) {
		if ((_inner_error_->domain == RYGEL_CMDLINE_CONFIG_ERROR) || (_inner_error_->domain == G_OPTION_ERROR)) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (parameter_string);
			_g_option_context_free0 (opt_context);
			return;
		} else {
			_g_free0 (parameter_string);
			_g_option_context_free0 (opt_context);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
#line 112 "rygel-cmdline-config.vala"
	if (rygel_cmdline_config_version) {
#line 113 "rygel-cmdline-config.vala"
		fprintf (stdout, "%s\n", PACKAGE_STRING);
#line 244 "rygel-cmdline-config.c"
		_inner_error_ = g_error_new_literal (RYGEL_CMDLINE_CONFIG_ERROR, RYGEL_CMDLINE_CONFIG_ERROR_VERSION_ONLY, "");
		{
			if ((_inner_error_->domain == RYGEL_CMDLINE_CONFIG_ERROR) || (_inner_error_->domain == G_OPTION_ERROR)) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (parameter_string);
				_g_option_context_free0 (opt_context);
				return;
			} else {
				_g_free0 (parameter_string);
				_g_option_context_free0 (opt_context);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_g_free0 (parameter_string);
	_g_option_context_free0 (opt_context);
}


#line 119 "rygel-cmdline-config.vala"
static gboolean rygel_cmdline_config_real_get_upnp_enabled (RygelConfiguration* base, GError** error) {
#line 268 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	gboolean result = FALSE;
	GError * _inner_error_;
	self = (RygelCmdlineConfig*) base;
	_inner_error_ = NULL;
	_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
	{
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
}


#line 123 "rygel-cmdline-config.vala"
static char* rygel_cmdline_config_real_get_interface (RygelConfiguration* base, GError** error) {
#line 284 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	char* result = NULL;
	GError * _inner_error_;
	self = (RygelCmdlineConfig*) base;
	_inner_error_ = NULL;
#line 124 "rygel-cmdline-config.vala"
	if (rygel_cmdline_config_iface == NULL) {
#line 292 "rygel-cmdline-config.c"
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			return NULL;
		}
	}
	result = g_strdup (rygel_cmdline_config_iface);
#line 128 "rygel-cmdline-config.vala"
	return result;
#line 302 "rygel-cmdline-config.c"
}


#line 131 "rygel-cmdline-config.vala"
static gint rygel_cmdline_config_real_get_port (RygelConfiguration* base, GError** error) {
#line 308 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	gint result = 0;
	GError * _inner_error_;
	self = (RygelCmdlineConfig*) base;
	_inner_error_ = NULL;
#line 132 "rygel-cmdline-config.vala"
	if (rygel_cmdline_config_port == (-1)) {
#line 316 "rygel-cmdline-config.c"
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			return 0;
		}
	}
	result = rygel_cmdline_config_port;
#line 136 "rygel-cmdline-config.vala"
	return result;
#line 326 "rygel-cmdline-config.c"
}


#line 139 "rygel-cmdline-config.vala"
static gboolean rygel_cmdline_config_real_get_transcoding (RygelConfiguration* base, GError** error) {
#line 332 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	gboolean result = FALSE;
	GError * _inner_error_;
	self = (RygelCmdlineConfig*) base;
	_inner_error_ = NULL;
#line 140 "rygel-cmdline-config.vala"
	if (!rygel_cmdline_config_no_transcoding) {
#line 340 "rygel-cmdline-config.c"
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			return FALSE;
		}
	} else {
		result = FALSE;
#line 143 "rygel-cmdline-config.vala"
		return result;
#line 350 "rygel-cmdline-config.c"
	}
}


#line 147 "rygel-cmdline-config.vala"
static gboolean rygel_cmdline_config_real_get_mp3_transcoder (RygelConfiguration* base, GError** error) {
#line 357 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	gboolean result = FALSE;
	GError * _inner_error_;
	self = (RygelCmdlineConfig*) base;
	_inner_error_ = NULL;
#line 148 "rygel-cmdline-config.vala"
	if (!rygel_cmdline_config_no_mp3_trans) {
#line 365 "rygel-cmdline-config.c"
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			return FALSE;
		}
	} else {
		result = FALSE;
#line 151 "rygel-cmdline-config.vala"
		return result;
#line 375 "rygel-cmdline-config.c"
	}
}


#line 155 "rygel-cmdline-config.vala"
static gboolean rygel_cmdline_config_real_get_mp2ts_transcoder (RygelConfiguration* base, GError** error) {
#line 382 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	gboolean result = FALSE;
	GError * _inner_error_;
	self = (RygelCmdlineConfig*) base;
	_inner_error_ = NULL;
#line 156 "rygel-cmdline-config.vala"
	if (!rygel_cmdline_config_no_mp2ts_trans) {
#line 390 "rygel-cmdline-config.c"
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			return FALSE;
		}
	} else {
		result = FALSE;
#line 159 "rygel-cmdline-config.vala"
		return result;
#line 400 "rygel-cmdline-config.c"
	}
}


#line 163 "rygel-cmdline-config.vala"
static gboolean rygel_cmdline_config_real_get_lpcm_transcoder (RygelConfiguration* base, GError** error) {
#line 407 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	gboolean result = FALSE;
	GError * _inner_error_;
	self = (RygelCmdlineConfig*) base;
	_inner_error_ = NULL;
#line 164 "rygel-cmdline-config.vala"
	if (!rygel_cmdline_config_no_lpcm_trans) {
#line 415 "rygel-cmdline-config.c"
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			return FALSE;
		}
	} else {
		result = FALSE;
#line 167 "rygel-cmdline-config.vala"
		return result;
#line 425 "rygel-cmdline-config.c"
	}
}


#line 171 "rygel-cmdline-config.vala"
static gboolean rygel_cmdline_config_real_get_wmv_transcoder (RygelConfiguration* base, GError** error) {
#line 432 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	gboolean result = FALSE;
	self = (RygelCmdlineConfig*) base;
	result = !rygel_cmdline_config_no_wmv_trans;
#line 172 "rygel-cmdline-config.vala"
	return result;
#line 439 "rygel-cmdline-config.c"
}


#line 175 "rygel-cmdline-config.vala"
static RygelLogLevel rygel_cmdline_config_real_get_log_level (RygelConfiguration* base, GError** error) {
#line 445 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	RygelLogLevel result = 0;
	GError * _inner_error_;
	self = (RygelCmdlineConfig*) base;
	_inner_error_ = NULL;
#line 176 "rygel-cmdline-config.vala"
	if (rygel_cmdline_config_log_level == RYGEL_LOG_LEVEL_INVALID) {
#line 453 "rygel-cmdline-config.c"
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			return 0;
		}
	}
	result = rygel_cmdline_config_log_level;
#line 180 "rygel-cmdline-config.vala"
	return result;
#line 463 "rygel-cmdline-config.c"
}


#line 183 "rygel-cmdline-config.vala"
static gboolean rygel_cmdline_config_real_get_enabled (RygelConfiguration* base, const char* section, GError** error) {
#line 469 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	gboolean result = FALSE;
	GError * _inner_error_;
	gboolean disabled;
	self = (RygelCmdlineConfig*) base;
#line 183 "rygel-cmdline-config.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 477 "rygel-cmdline-config.c"
	_inner_error_ = NULL;
#line 184 "rygel-cmdline-config.vala"
	disabled = FALSE;
#line 481 "rygel-cmdline-config.c"
	{
		char** plugin_collection;
		int plugin_collection_length1;
		int plugin_it;
#line 185 "rygel-cmdline-config.vala"
		plugin_collection = rygel_cmdline_config_disabled_plugins;
#line 488 "rygel-cmdline-config.c"
		plugin_collection_length1 = _vala_array_length (rygel_cmdline_config_disabled_plugins);
		for (plugin_it = 0; plugin_it < _vala_array_length (rygel_cmdline_config_disabled_plugins); plugin_it = plugin_it + 1) {
			char* plugin;
			plugin = g_strdup (plugin_collection[plugin_it]);
			{
#line 186 "rygel-cmdline-config.vala"
				if (_vala_strcmp0 (plugin, section) == 0) {
#line 187 "rygel-cmdline-config.vala"
					disabled = TRUE;
#line 498 "rygel-cmdline-config.c"
					_g_free0 (plugin);
#line 188 "rygel-cmdline-config.vala"
					break;
#line 502 "rygel-cmdline-config.c"
				}
				_g_free0 (plugin);
			}
		}
	}
#line 192 "rygel-cmdline-config.vala"
	if (disabled) {
#line 510 "rygel-cmdline-config.c"
		result = FALSE;
#line 193 "rygel-cmdline-config.vala"
		return result;
#line 514 "rygel-cmdline-config.c"
	} else {
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			return FALSE;
		}
	}
}


#line 199 "rygel-cmdline-config.vala"
static char* rygel_cmdline_config_real_get_title (RygelConfiguration* base, const char* section, GError** error) {
#line 527 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	char* result = NULL;
	GError * _inner_error_;
	char* title;
	self = (RygelCmdlineConfig*) base;
#line 199 "rygel-cmdline-config.vala"
	g_return_val_if_fail (section != NULL, NULL);
#line 535 "rygel-cmdline-config.c"
	_inner_error_ = NULL;
#line 200 "rygel-cmdline-config.vala"
	title = NULL;
#line 539 "rygel-cmdline-config.c"
	{
		char** plugin_title_collection;
		int plugin_title_collection_length1;
		int plugin_title_it;
#line 201 "rygel-cmdline-config.vala"
		plugin_title_collection = rygel_cmdline_config_plugin_titles;
#line 546 "rygel-cmdline-config.c"
		plugin_title_collection_length1 = _vala_array_length (rygel_cmdline_config_plugin_titles);
		for (plugin_title_it = 0; plugin_title_it < _vala_array_length (rygel_cmdline_config_plugin_titles); plugin_title_it = plugin_title_it + 1) {
			char* plugin_title;
			plugin_title = g_strdup (plugin_title_collection[plugin_title_it]);
			{
				char** _tmp1_;
				gint _tokens_size_;
				gint tokens_length1;
				char** _tmp0_;
				char** tokens;
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				tokens = (_tmp1_ = _tmp0_ = g_strsplit (plugin_title, ":", 2), tokens_length1 = _vala_array_length (_tmp0_), _tokens_size_ = tokens_length1, _tmp1_);
#line 203 "rygel-cmdline-config.vala"
				if (tokens[0] != NULL) {
#line 204 "rygel-cmdline-config.vala"
					_tmp3_ = tokens[1] != NULL;
#line 564 "rygel-cmdline-config.c"
				} else {
#line 203 "rygel-cmdline-config.vala"
					_tmp3_ = FALSE;
#line 568 "rygel-cmdline-config.c"
				}
#line 203 "rygel-cmdline-config.vala"
				if (_tmp3_) {
#line 205 "rygel-cmdline-config.vala"
					_tmp2_ = _vala_strcmp0 (tokens[0], section) == 0;
#line 574 "rygel-cmdline-config.c"
				} else {
#line 203 "rygel-cmdline-config.vala"
					_tmp2_ = FALSE;
#line 578 "rygel-cmdline-config.c"
				}
#line 203 "rygel-cmdline-config.vala"
				if (_tmp2_) {
#line 582 "rygel-cmdline-config.c"
					char* _tmp4_;
#line 206 "rygel-cmdline-config.vala"
					title = (_tmp4_ = g_strdup (tokens[1]), _g_free0 (title), _tmp4_);
#line 586 "rygel-cmdline-config.c"
					_g_free0 (plugin_title);
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 207 "rygel-cmdline-config.vala"
					break;
#line 591 "rygel-cmdline-config.c"
				}
				_g_free0 (plugin_title);
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
#line 211 "rygel-cmdline-config.vala"
	if (title != NULL) {
#line 600 "rygel-cmdline-config.c"
		result = title;
#line 212 "rygel-cmdline-config.vala"
		return result;
#line 604 "rygel-cmdline-config.c"
	} else {
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			_g_free0 (title);
			return NULL;
		}
	}
	_g_free0 (title);
}


#line 220 "rygel-cmdline-config.vala"
static char* rygel_cmdline_config_real_get_string (RygelConfiguration* base, const char* section, const char* key, GError** error) {
#line 619 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	char* result = NULL;
	GError * _inner_error_;
	char* value;
	self = (RygelCmdlineConfig*) base;
#line 220 "rygel-cmdline-config.vala"
	g_return_val_if_fail (section != NULL, NULL);
#line 220 "rygel-cmdline-config.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 629 "rygel-cmdline-config.c"
	_inner_error_ = NULL;
#line 222 "rygel-cmdline-config.vala"
	value = NULL;
#line 633 "rygel-cmdline-config.c"
	{
		char** option_collection;
		int option_collection_length1;
		int option_it;
#line 223 "rygel-cmdline-config.vala"
		option_collection = rygel_cmdline_config_plugin_options;
#line 640 "rygel-cmdline-config.c"
		option_collection_length1 = _vala_array_length (rygel_cmdline_config_plugin_options);
		for (option_it = 0; option_it < _vala_array_length (rygel_cmdline_config_plugin_options); option_it = option_it + 1) {
			char* option;
			option = g_strdup (option_collection[option_it]);
			{
				char** _tmp1_;
				gint _tokens_size_;
				gint tokens_length1;
				char** _tmp0_;
				char** tokens;
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				tokens = (_tmp1_ = _tmp0_ = g_strsplit (option, ":", 3), tokens_length1 = _vala_array_length (_tmp0_), _tokens_size_ = tokens_length1, _tmp1_);
#line 225 "rygel-cmdline-config.vala"
				if (tokens[0] != NULL) {
#line 226 "rygel-cmdline-config.vala"
					_tmp5_ = tokens[1] != NULL;
#line 660 "rygel-cmdline-config.c"
				} else {
#line 225 "rygel-cmdline-config.vala"
					_tmp5_ = FALSE;
#line 664 "rygel-cmdline-config.c"
				}
#line 225 "rygel-cmdline-config.vala"
				if (_tmp5_) {
#line 227 "rygel-cmdline-config.vala"
					_tmp4_ = tokens[2] != NULL;
#line 670 "rygel-cmdline-config.c"
				} else {
#line 225 "rygel-cmdline-config.vala"
					_tmp4_ = FALSE;
#line 674 "rygel-cmdline-config.c"
				}
#line 225 "rygel-cmdline-config.vala"
				if (_tmp4_) {
#line 228 "rygel-cmdline-config.vala"
					_tmp3_ = _vala_strcmp0 (tokens[0], section) == 0;
#line 680 "rygel-cmdline-config.c"
				} else {
#line 225 "rygel-cmdline-config.vala"
					_tmp3_ = FALSE;
#line 684 "rygel-cmdline-config.c"
				}
#line 225 "rygel-cmdline-config.vala"
				if (_tmp3_) {
#line 229 "rygel-cmdline-config.vala"
					_tmp2_ = _vala_strcmp0 (tokens[1], key) == 0;
#line 690 "rygel-cmdline-config.c"
				} else {
#line 225 "rygel-cmdline-config.vala"
					_tmp2_ = FALSE;
#line 694 "rygel-cmdline-config.c"
				}
#line 225 "rygel-cmdline-config.vala"
				if (_tmp2_) {
#line 698 "rygel-cmdline-config.c"
					char* _tmp6_;
#line 230 "rygel-cmdline-config.vala"
					value = (_tmp6_ = g_strdup (tokens[2]), _g_free0 (value), _tmp6_);
#line 702 "rygel-cmdline-config.c"
					_g_free0 (option);
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 231 "rygel-cmdline-config.vala"
					break;
#line 707 "rygel-cmdline-config.c"
				}
				_g_free0 (option);
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
#line 235 "rygel-cmdline-config.vala"
	if (value != NULL) {
#line 716 "rygel-cmdline-config.c"
		result = value;
#line 236 "rygel-cmdline-config.vala"
		return result;
#line 720 "rygel-cmdline-config.c"
	} else {
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			_g_free0 (value);
			return NULL;
		}
	}
	_g_free0 (value);
}


#line 242 "rygel-cmdline-config.vala"
static GeeArrayList* rygel_cmdline_config_real_get_string_list (RygelConfiguration* base, const char* section, const char* key, GError** error) {
#line 735 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	GeeArrayList* result = NULL;
	GError * _inner_error_;
	GeeArrayList* value;
	self = (RygelCmdlineConfig*) base;
#line 242 "rygel-cmdline-config.vala"
	g_return_val_if_fail (section != NULL, NULL);
#line 242 "rygel-cmdline-config.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 745 "rygel-cmdline-config.c"
	_inner_error_ = NULL;
#line 245 "rygel-cmdline-config.vala"
	value = NULL;
#line 749 "rygel-cmdline-config.c"
	{
		char** option_collection;
		int option_collection_length1;
		int option_it;
#line 246 "rygel-cmdline-config.vala"
		option_collection = rygel_cmdline_config_plugin_options;
#line 756 "rygel-cmdline-config.c"
		option_collection_length1 = _vala_array_length (rygel_cmdline_config_plugin_options);
		for (option_it = 0; option_it < _vala_array_length (rygel_cmdline_config_plugin_options); option_it = option_it + 1) {
			char* option;
			option = g_strdup (option_collection[option_it]);
			{
				char** _tmp1_;
				gint _tokens_size_;
				gint tokens_length1;
				char** _tmp0_;
				char** tokens;
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				tokens = (_tmp1_ = _tmp0_ = g_strsplit (option, ":", 3), tokens_length1 = _vala_array_length (_tmp0_), _tokens_size_ = tokens_length1, _tmp1_);
#line 248 "rygel-cmdline-config.vala"
				if (tokens[0] != NULL) {
#line 249 "rygel-cmdline-config.vala"
					_tmp5_ = tokens[1] != NULL;
#line 776 "rygel-cmdline-config.c"
				} else {
#line 248 "rygel-cmdline-config.vala"
					_tmp5_ = FALSE;
#line 780 "rygel-cmdline-config.c"
				}
#line 248 "rygel-cmdline-config.vala"
				if (_tmp5_) {
#line 250 "rygel-cmdline-config.vala"
					_tmp4_ = tokens[2] != NULL;
#line 786 "rygel-cmdline-config.c"
				} else {
#line 248 "rygel-cmdline-config.vala"
					_tmp4_ = FALSE;
#line 790 "rygel-cmdline-config.c"
				}
#line 248 "rygel-cmdline-config.vala"
				if (_tmp4_) {
#line 251 "rygel-cmdline-config.vala"
					_tmp3_ = _vala_strcmp0 (tokens[0], section) == 0;
#line 796 "rygel-cmdline-config.c"
				} else {
#line 248 "rygel-cmdline-config.vala"
					_tmp3_ = FALSE;
#line 800 "rygel-cmdline-config.c"
				}
#line 248 "rygel-cmdline-config.vala"
				if (_tmp3_) {
#line 252 "rygel-cmdline-config.vala"
					_tmp2_ = _vala_strcmp0 (tokens[1], key) == 0;
#line 806 "rygel-cmdline-config.c"
				} else {
#line 248 "rygel-cmdline-config.vala"
					_tmp2_ = FALSE;
#line 810 "rygel-cmdline-config.c"
				}
#line 248 "rygel-cmdline-config.vala"
				if (_tmp2_) {
#line 814 "rygel-cmdline-config.c"
					GeeArrayList* _tmp6_;
#line 253 "rygel-cmdline-config.vala"
					value = (_tmp6_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL), _g_object_unref0 (value), _tmp6_);
#line 818 "rygel-cmdline-config.c"
					{
						char** _tmp7_;
						char** val_token_collection;
						int val_token_collection_length1;
						int val_token_it;
#line 254 "rygel-cmdline-config.vala"
						val_token_collection = _tmp7_ = g_strsplit (tokens[2], ",", -1);
#line 826 "rygel-cmdline-config.c"
						val_token_collection_length1 = _vala_array_length (_tmp7_);
						for (val_token_it = 0; val_token_it < _vala_array_length (_tmp7_); val_token_it = val_token_it + 1) {
							char* val_token;
							val_token = g_strdup (val_token_collection[val_token_it]);
							{
#line 255 "rygel-cmdline-config.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) value, val_token);
#line 834 "rygel-cmdline-config.c"
								_g_free0 (val_token);
							}
						}
#line 254 "rygel-cmdline-config.vala"
						val_token_collection = (_vala_array_free (val_token_collection, val_token_collection_length1, (GDestroyNotify) g_free), NULL);
#line 840 "rygel-cmdline-config.c"
					}
					_g_free0 (option);
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 257 "rygel-cmdline-config.vala"
					break;
#line 846 "rygel-cmdline-config.c"
				}
				_g_free0 (option);
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
#line 261 "rygel-cmdline-config.vala"
	if (value != NULL) {
#line 855 "rygel-cmdline-config.c"
		result = value;
#line 262 "rygel-cmdline-config.vala"
		return result;
#line 859 "rygel-cmdline-config.c"
	} else {
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (value);
			return NULL;
		}
	}
	_g_object_unref0 (value);
}


#line 268 "rygel-cmdline-config.vala"
static gint rygel_cmdline_config_real_get_int (RygelConfiguration* base, const char* section, const char* key, gint min, gint max, GError** error) {
#line 874 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	gint result = 0;
	GError * _inner_error_;
	gint value;
	gboolean value_set;
	self = (RygelCmdlineConfig*) base;
#line 268 "rygel-cmdline-config.vala"
	g_return_val_if_fail (section != NULL, 0);
#line 268 "rygel-cmdline-config.vala"
	g_return_val_if_fail (key != NULL, 0);
#line 885 "rygel-cmdline-config.c"
	_inner_error_ = NULL;
#line 273 "rygel-cmdline-config.vala"
	value = 0;
#line 274 "rygel-cmdline-config.vala"
	value_set = FALSE;
#line 891 "rygel-cmdline-config.c"
	{
		char** option_collection;
		int option_collection_length1;
		int option_it;
#line 275 "rygel-cmdline-config.vala"
		option_collection = rygel_cmdline_config_plugin_options;
#line 898 "rygel-cmdline-config.c"
		option_collection_length1 = _vala_array_length (rygel_cmdline_config_plugin_options);
		for (option_it = 0; option_it < _vala_array_length (rygel_cmdline_config_plugin_options); option_it = option_it + 1) {
			char* option;
			option = g_strdup (option_collection[option_it]);
			{
				char** _tmp1_;
				gint _tokens_size_;
				gint tokens_length1;
				char** _tmp0_;
				char** tokens;
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				tokens = (_tmp1_ = _tmp0_ = g_strsplit (option, ":", 3), tokens_length1 = _vala_array_length (_tmp0_), _tokens_size_ = tokens_length1, _tmp1_);
#line 277 "rygel-cmdline-config.vala"
				if (tokens[0] != NULL) {
#line 278 "rygel-cmdline-config.vala"
					_tmp5_ = tokens[1] != NULL;
#line 918 "rygel-cmdline-config.c"
				} else {
#line 277 "rygel-cmdline-config.vala"
					_tmp5_ = FALSE;
#line 922 "rygel-cmdline-config.c"
				}
#line 277 "rygel-cmdline-config.vala"
				if (_tmp5_) {
#line 279 "rygel-cmdline-config.vala"
					_tmp4_ = tokens[2] != NULL;
#line 928 "rygel-cmdline-config.c"
				} else {
#line 277 "rygel-cmdline-config.vala"
					_tmp4_ = FALSE;
#line 932 "rygel-cmdline-config.c"
				}
#line 277 "rygel-cmdline-config.vala"
				if (_tmp4_) {
#line 280 "rygel-cmdline-config.vala"
					_tmp3_ = _vala_strcmp0 (tokens[0], section) == 0;
#line 938 "rygel-cmdline-config.c"
				} else {
#line 277 "rygel-cmdline-config.vala"
					_tmp3_ = FALSE;
#line 942 "rygel-cmdline-config.c"
				}
#line 277 "rygel-cmdline-config.vala"
				if (_tmp3_) {
#line 281 "rygel-cmdline-config.vala"
					_tmp2_ = _vala_strcmp0 (tokens[1], key) == 0;
#line 948 "rygel-cmdline-config.c"
				} else {
#line 277 "rygel-cmdline-config.vala"
					_tmp2_ = FALSE;
#line 952 "rygel-cmdline-config.c"
				}
#line 277 "rygel-cmdline-config.vala"
				if (_tmp2_) {
#line 956 "rygel-cmdline-config.c"
					gboolean _tmp6_ = FALSE;
#line 282 "rygel-cmdline-config.vala"
					value = atoi (tokens[2]);
#line 283 "rygel-cmdline-config.vala"
					if (value >= min) {
#line 283 "rygel-cmdline-config.vala"
						_tmp6_ = value <= max;
#line 964 "rygel-cmdline-config.c"
					} else {
#line 283 "rygel-cmdline-config.vala"
						_tmp6_ = FALSE;
#line 968 "rygel-cmdline-config.c"
					}
#line 283 "rygel-cmdline-config.vala"
					if (_tmp6_) {
#line 284 "rygel-cmdline-config.vala"
						value_set = TRUE;
#line 974 "rygel-cmdline-config.c"
					}
					_g_free0 (option);
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 286 "rygel-cmdline-config.vala"
					break;
#line 980 "rygel-cmdline-config.c"
				}
				_g_free0 (option);
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
#line 290 "rygel-cmdline-config.vala"
	if (value_set) {
#line 989 "rygel-cmdline-config.c"
		result = value;
#line 291 "rygel-cmdline-config.vala"
		return result;
#line 993 "rygel-cmdline-config.c"
	} else {
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			return 0;
		}
	}
}


#line 297 "rygel-cmdline-config.vala"
static GeeArrayList* rygel_cmdline_config_real_get_int_list (RygelConfiguration* base, const char* section, const char* key, GError** error) {
#line 1006 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	GeeArrayList* result = NULL;
	GError * _inner_error_;
	GeeArrayList* value;
	self = (RygelCmdlineConfig*) base;
#line 297 "rygel-cmdline-config.vala"
	g_return_val_if_fail (section != NULL, NULL);
#line 297 "rygel-cmdline-config.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 1016 "rygel-cmdline-config.c"
	_inner_error_ = NULL;
#line 300 "rygel-cmdline-config.vala"
	value = NULL;
#line 1020 "rygel-cmdline-config.c"
	{
		char** option_collection;
		int option_collection_length1;
		int option_it;
#line 301 "rygel-cmdline-config.vala"
		option_collection = rygel_cmdline_config_plugin_options;
#line 1027 "rygel-cmdline-config.c"
		option_collection_length1 = _vala_array_length (rygel_cmdline_config_plugin_options);
		for (option_it = 0; option_it < _vala_array_length (rygel_cmdline_config_plugin_options); option_it = option_it + 1) {
			char* option;
			option = g_strdup (option_collection[option_it]);
			{
				char** _tmp1_;
				gint _tokens_size_;
				gint tokens_length1;
				char** _tmp0_;
				char** tokens;
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				tokens = (_tmp1_ = _tmp0_ = g_strsplit (option, ":", 3), tokens_length1 = _vala_array_length (_tmp0_), _tokens_size_ = tokens_length1, _tmp1_);
#line 303 "rygel-cmdline-config.vala"
				if (tokens[0] != NULL) {
#line 304 "rygel-cmdline-config.vala"
					_tmp5_ = tokens[1] != NULL;
#line 1047 "rygel-cmdline-config.c"
				} else {
#line 303 "rygel-cmdline-config.vala"
					_tmp5_ = FALSE;
#line 1051 "rygel-cmdline-config.c"
				}
#line 303 "rygel-cmdline-config.vala"
				if (_tmp5_) {
#line 305 "rygel-cmdline-config.vala"
					_tmp4_ = tokens[2] != NULL;
#line 1057 "rygel-cmdline-config.c"
				} else {
#line 303 "rygel-cmdline-config.vala"
					_tmp4_ = FALSE;
#line 1061 "rygel-cmdline-config.c"
				}
#line 303 "rygel-cmdline-config.vala"
				if (_tmp4_) {
#line 306 "rygel-cmdline-config.vala"
					_tmp3_ = _vala_strcmp0 (tokens[0], section) == 0;
#line 1067 "rygel-cmdline-config.c"
				} else {
#line 303 "rygel-cmdline-config.vala"
					_tmp3_ = FALSE;
#line 1071 "rygel-cmdline-config.c"
				}
#line 303 "rygel-cmdline-config.vala"
				if (_tmp3_) {
#line 307 "rygel-cmdline-config.vala"
					_tmp2_ = _vala_strcmp0 (tokens[1], key) == 0;
#line 1077 "rygel-cmdline-config.c"
				} else {
#line 303 "rygel-cmdline-config.vala"
					_tmp2_ = FALSE;
#line 1081 "rygel-cmdline-config.c"
				}
#line 303 "rygel-cmdline-config.vala"
				if (_tmp2_) {
#line 1085 "rygel-cmdline-config.c"
					GeeArrayList* _tmp6_;
#line 308 "rygel-cmdline-config.vala"
					value = (_tmp6_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL), _g_object_unref0 (value), _tmp6_);
#line 1089 "rygel-cmdline-config.c"
					{
						char** _tmp7_;
						char** val_token_collection;
						int val_token_collection_length1;
						int val_token_it;
#line 309 "rygel-cmdline-config.vala"
						val_token_collection = _tmp7_ = g_strsplit (tokens[2], ",", -1);
#line 1097 "rygel-cmdline-config.c"
						val_token_collection_length1 = _vala_array_length (_tmp7_);
						for (val_token_it = 0; val_token_it < _vala_array_length (_tmp7_); val_token_it = val_token_it + 1) {
							char* val_token;
							val_token = g_strdup (val_token_collection[val_token_it]);
							{
#line 310 "rygel-cmdline-config.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) value, GINT_TO_POINTER (atoi (val_token)));
#line 1105 "rygel-cmdline-config.c"
								_g_free0 (val_token);
							}
						}
#line 309 "rygel-cmdline-config.vala"
						val_token_collection = (_vala_array_free (val_token_collection, val_token_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1111 "rygel-cmdline-config.c"
					}
					_g_free0 (option);
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 312 "rygel-cmdline-config.vala"
					break;
#line 1117 "rygel-cmdline-config.c"
				}
				_g_free0 (option);
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
#line 316 "rygel-cmdline-config.vala"
	if (value != NULL) {
#line 1126 "rygel-cmdline-config.c"
		result = value;
#line 317 "rygel-cmdline-config.vala"
		return result;
#line 1130 "rygel-cmdline-config.c"
	} else {
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (value);
			return NULL;
		}
	}
	_g_object_unref0 (value);
}


#line 952 "glib-2.0.vapi"
static gboolean string_to_bool (const char* self) {
#line 1145 "rygel-cmdline-config.c"
	gboolean result = FALSE;
#line 952 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 953 "glib-2.0.vapi"
	if (_vala_strcmp0 (self, "true") == 0) {
#line 1151 "rygel-cmdline-config.c"
		result = TRUE;
#line 954 "glib-2.0.vapi"
		return result;
#line 1155 "rygel-cmdline-config.c"
	} else {
		result = FALSE;
#line 956 "glib-2.0.vapi"
		return result;
#line 1160 "rygel-cmdline-config.c"
	}
}


#line 323 "rygel-cmdline-config.vala"
static gboolean rygel_cmdline_config_real_get_bool (RygelConfiguration* base, const char* section, const char* key, GError** error) {
#line 1167 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
	gboolean result = FALSE;
	GError * _inner_error_;
	gboolean value;
	gboolean value_set;
	self = (RygelCmdlineConfig*) base;
#line 323 "rygel-cmdline-config.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 323 "rygel-cmdline-config.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 1178 "rygel-cmdline-config.c"
	_inner_error_ = NULL;
#line 326 "rygel-cmdline-config.vala"
	value = FALSE;
#line 327 "rygel-cmdline-config.vala"
	value_set = FALSE;
#line 1184 "rygel-cmdline-config.c"
	{
		char** option_collection;
		int option_collection_length1;
		int option_it;
#line 328 "rygel-cmdline-config.vala"
		option_collection = rygel_cmdline_config_plugin_options;
#line 1191 "rygel-cmdline-config.c"
		option_collection_length1 = _vala_array_length (rygel_cmdline_config_plugin_options);
		for (option_it = 0; option_it < _vala_array_length (rygel_cmdline_config_plugin_options); option_it = option_it + 1) {
			char* option;
			option = g_strdup (option_collection[option_it]);
			{
				char** _tmp1_;
				gint _tokens_size_;
				gint tokens_length1;
				char** _tmp0_;
				char** tokens;
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				tokens = (_tmp1_ = _tmp0_ = g_strsplit (option, ":", 3), tokens_length1 = _vala_array_length (_tmp0_), _tokens_size_ = tokens_length1, _tmp1_);
#line 330 "rygel-cmdline-config.vala"
				if (tokens[0] != NULL) {
#line 331 "rygel-cmdline-config.vala"
					_tmp5_ = tokens[1] != NULL;
#line 1211 "rygel-cmdline-config.c"
				} else {
#line 330 "rygel-cmdline-config.vala"
					_tmp5_ = FALSE;
#line 1215 "rygel-cmdline-config.c"
				}
#line 330 "rygel-cmdline-config.vala"
				if (_tmp5_) {
#line 332 "rygel-cmdline-config.vala"
					_tmp4_ = tokens[2] != NULL;
#line 1221 "rygel-cmdline-config.c"
				} else {
#line 330 "rygel-cmdline-config.vala"
					_tmp4_ = FALSE;
#line 1225 "rygel-cmdline-config.c"
				}
#line 330 "rygel-cmdline-config.vala"
				if (_tmp4_) {
#line 333 "rygel-cmdline-config.vala"
					_tmp3_ = _vala_strcmp0 (tokens[0], section) == 0;
#line 1231 "rygel-cmdline-config.c"
				} else {
#line 330 "rygel-cmdline-config.vala"
					_tmp3_ = FALSE;
#line 1235 "rygel-cmdline-config.c"
				}
#line 330 "rygel-cmdline-config.vala"
				if (_tmp3_) {
#line 334 "rygel-cmdline-config.vala"
					_tmp2_ = _vala_strcmp0 (tokens[1], key) == 0;
#line 1241 "rygel-cmdline-config.c"
				} else {
#line 330 "rygel-cmdline-config.vala"
					_tmp2_ = FALSE;
#line 1245 "rygel-cmdline-config.c"
				}
#line 330 "rygel-cmdline-config.vala"
				if (_tmp2_) {
#line 335 "rygel-cmdline-config.vala"
					value = string_to_bool (tokens[2]);
#line 336 "rygel-cmdline-config.vala"
					value_set = TRUE;
#line 1253 "rygel-cmdline-config.c"
					_g_free0 (option);
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 337 "rygel-cmdline-config.vala"
					break;
#line 1258 "rygel-cmdline-config.c"
				}
				_g_free0 (option);
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
#line 341 "rygel-cmdline-config.vala"
	if (value_set) {
#line 1267 "rygel-cmdline-config.c"
		result = value;
#line 342 "rygel-cmdline-config.vala"
		return result;
#line 1271 "rygel-cmdline-config.c"
	} else {
		_inner_error_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, "No value available");
		{
			g_propagate_error (error, _inner_error_);
			return FALSE;
		}
	}
}


#line 35 "rygel-cmdline-config.vala"
RygelCmdlineConfig* rygel_cmdline_config_construct (GType object_type) {
#line 1284 "rygel-cmdline-config.c"
	RygelCmdlineConfig * self;
#line 35 "rygel-cmdline-config.vala"
	self = (RygelCmdlineConfig*) g_object_new (object_type, NULL);
#line 1288 "rygel-cmdline-config.c"
	return self;
}


#line 35 "rygel-cmdline-config.vala"
RygelCmdlineConfig* rygel_cmdline_config_new (void) {
#line 35 "rygel-cmdline-config.vala"
	return rygel_cmdline_config_construct (RYGEL_TYPE_CMDLINE_CONFIG);
#line 1297 "rygel-cmdline-config.c"
}


static void rygel_cmdline_config_class_init (RygelCmdlineConfigClass * klass) {
	rygel_cmdline_config_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = rygel_cmdline_config_finalize;
	rygel_cmdline_config_port = -1;
}


static void rygel_cmdline_config_rygel_configuration_interface_init (RygelConfigurationIface * iface) {
	rygel_cmdline_config_rygel_configuration_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_upnp_enabled = rygel_cmdline_config_real_get_upnp_enabled;
	iface->get_interface = rygel_cmdline_config_real_get_interface;
	iface->get_port = rygel_cmdline_config_real_get_port;
	iface->get_transcoding = rygel_cmdline_config_real_get_transcoding;
	iface->get_mp3_transcoder = rygel_cmdline_config_real_get_mp3_transcoder;
	iface->get_mp2ts_transcoder = rygel_cmdline_config_real_get_mp2ts_transcoder;
	iface->get_lpcm_transcoder = rygel_cmdline_config_real_get_lpcm_transcoder;
	iface->get_wmv_transcoder = rygel_cmdline_config_real_get_wmv_transcoder;
	iface->get_log_level = rygel_cmdline_config_real_get_log_level;
	iface->get_enabled = rygel_cmdline_config_real_get_enabled;
	iface->get_title = rygel_cmdline_config_real_get_title;
	iface->get_string = rygel_cmdline_config_real_get_string;
	iface->get_string_list = rygel_cmdline_config_real_get_string_list;
	iface->get_int = rygel_cmdline_config_real_get_int;
	iface->get_int_list = rygel_cmdline_config_real_get_int_list;
	iface->get_bool = rygel_cmdline_config_real_get_bool;
}


static void rygel_cmdline_config_instance_init (RygelCmdlineConfig * self) {
}


static void rygel_cmdline_config_finalize (GObject* obj) {
	RygelCmdlineConfig * self;
	self = RYGEL_CMDLINE_CONFIG (obj);
	G_OBJECT_CLASS (rygel_cmdline_config_parent_class)->finalize (obj);
}


GType rygel_cmdline_config_get_type (void) {
	static volatile gsize rygel_cmdline_config_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_cmdline_config_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelCmdlineConfigClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_cmdline_config_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelCmdlineConfig), 0, (GInstanceInitFunc) rygel_cmdline_config_instance_init, NULL };
		static const GInterfaceInfo rygel_configuration_info = { (GInterfaceInitFunc) rygel_cmdline_config_rygel_configuration_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType rygel_cmdline_config_type_id;
		rygel_cmdline_config_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelCmdlineConfig", &g_define_type_info, 0);
		g_type_add_interface_static (rygel_cmdline_config_type_id, RYGEL_TYPE_CONFIGURATION, &rygel_configuration_info);
		g_once_init_leave (&rygel_cmdline_config_type_id__volatile, rygel_cmdline_config_type_id);
	}
	return rygel_cmdline_config_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




